HDU 1531差分约束

K i n g King King

Time Limit: 2000/1000 MS (Java/Others)Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 2376Accepted Submission(s): 1061

Problem Description
Once, in one kingdom, there was a queen and that queen was expecting a baby. The queen prayed: ``If my child was a son and if only he was a sound king.’’ After nine months her child was born, and indeed, she gave birth to a nice son.
Unfortunately, as it used to happen in royal families, the son was a little retarded. After many years of study he was able just to add integer numbers and to compare whether the result is greater or less than a given integer number. In addition, the numbers had to be written in a sequence and he was able to sum just continuous subsequences of the sequence.

The old king was very unhappy of his son. But he was ready to make everything to enable his son to govern the kingdom after his death. With regards to his son’s skills he decided that every problem the king had to decide about had to be presented in a form of a finite sequence of integer numbers and the decision about it would be done by stating an integer constraint (i.e. an upper or lower limit) for the sum of that sequence. In this way there was at least some hope that his son would be able to make some decisions.

After the old king died, the young king began to reign. But very soon, a lot of people became very unsatisfied with his decisions and decided to dethrone him. They tried to do it by proving that his decisions were wrong.

Therefore some conspirators presented to the young king a set of problems that he had to decide about. The set of problems was in the form of subsequences Si = {aSi, aSi+1, …, aSi+ni} of a sequence S = {a1, a2, …, an}. The king thought a minute and then decided, i.e. he set for the sum aSi + aSi+1 + … + aSi+ni of each subsequence Si an integer constraint ki (i.e. aSi + aSi+1 + … + aSi+ni < ki or aSi + aSi+1 + … + aSi+ni > ki resp.) and declared these constraints as his decisions.

After a while he realized that some of his decisions were wrong. He could not revoke the declared constraints but trying to save himself he decided to fake the sequence that he was given. He ordered to his advisors to find such a sequence S that would satisfy the constraints he set. Help the advisors of the king and write a program that decides whether such a sequence exists or not.

Input
The input consists of blocks of lines. Each block except the last corresponds to one set of problems and king’s decisions about them. In the first line of the block there are integers n, and m where 0 < n <= 100 is length of the sequence S and 0 < m <= 100 is the number of subsequences Si. Next m lines contain particular decisions coded in the form of quadruples si, ni, oi, ki, where oi represents operator > (coded as gt) or operator < (coded as lt) respectively. The symbols si, ni and ki have the meaning described above. The last block consists of just one line containing 0.

Output
The output contains the lines corresponding to the blocks in the input. A line contains text successful conspiracy when such a sequence does not exist. Otherwise it contains text lamentable kingdom. There is no line in the output corresponding to the last ``null’’ block of the input.

Sample Input
4 2
1 2 gt 0
2 2 lt 2
1 2
1 0 gt 0
1 0 lt 0
0

Sample Output
lamentable kingdom
successful conspiracy

Source
Central Europe 1997

一开始看了半天题目没看懂意思,看了题解才懵逼地写出来的。

题目大意:

有一段序列A长度为n(注意!!是从0到n),然后给出m个条件,每个条件表示如下:
st,len,op,k;其中st、len、k为整数,op为字符串gt(greater then)或lt(less then),op为gt时表示约束条件为序列从A[st]到A[st+len]的和大于k,op为lt时表示约束条件为序列从A[st]到A[st+len]的和小于k,问是否存在这样的序列

分析:

其实就是题目意思不是很清楚,如果理解了题意的话就很简单了,对于区间和我们可以用前缀和相减来表示,对于两种约束条件分别表示为:
A[st+len] - A[st-1] > k,op = gt
A[st-len] - A[st-1] < k ,op = lt

然后把两种式子变形成同一种形式,就可以用差分约束来解决了
①A[st+len] - A[st-1] >= k+1, op = gt
②A[st-1] - A[st+len] >= 1-k,op = lt

对于①建边:Node(st-1)->Node(st+len) 长度为k+1
对于②建边:Node(st+len)->Node(st-1) 长度为1-k
由于起始点有0点,所以把所有点往后移1个单位,0点前缀和为0
0点表示为超级源点,0点对所有其他点建边,长度为0

对于建好的图用SPFA跑一遍最长路径判断是否有正环就好了
注意这里包括0点一共有n+2个点,所以判断正环的时候是>n+1
AC代码:

#include<cstdio>
#include<cstring>
#include<queue>
#include<algorithm>
#include<vector>
using namespace std;
const int maxn = 111;
const int INF = 0x3f3f3f3f;
struct EDGE{
    int to,cost;
};
vector<EDGE> G[maxn];
int n,m;
void add_edge(int u,int v,int c){
    G[u].push_back((EDGE){v,c});
}
void input_build(){
    scanf("%d",&m);
    for(int i=0;i<maxn;i++) G[i].clear();
    for(int i=1;i<=m;i++){
        int st,len,k;
        char s[5];
        scanf("%d %d %s %d",&st,&len,s,&k); st++;
        if(s[0]=='g') add_edge(st-1,st+len,k+1);
        else if(s[0]=='l') add_edge(st+len,st-1,-(k-1));
    }
    for(int i=1;i<=n+1;i++) add_edge(0,i,0);
}
bool SPFA(){        //找最长路径
    int vis[maxn],dist[maxn],inqueue[maxn];
    memset(vis,0,sizeof(vis));
    memset(dist,-INF,sizeof(dist));
    memset(inqueue,0,sizeof(inqueue));
    dist[0] = 0;vis[0] = inqueue[0] = 1;
    queue<int> que;
    que.push(0);
    while(!que.empty()){
        int now = que.front();
        que.pop(); vis[now] = 0;
        for(int i=0;i<G[now].size();i++){
            EDGE e = G[now][i];
            if(dist[e.to]<dist[now] + e.cost){
                dist[e.to] = dist[now] + e.cost;
                if(!vis[e.to]){
                    if(++inqueue[e.to]>n+1) return false;
                    vis[e.to] = 1;
                    que.push(e.to);
                }
            }
        }
    }
    return true;
}
int main(){
    while(scanf("%d",&n)!=EOF&&n){
        input_build();
        if(SPFA()) printf("lamentable kingdom\n");
        else printf("successful conspiracy\n");
    }
    return 0;
}

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值